--- /dev/null	2014-01-14 16:47:44.000000000 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/arithmetic/tst.nonarrow.ksh	2014-01-14 16:47:44.744586274 -0500
@@ -0,0 +1,48 @@
+#
+# CDDL HEADER START
+#
+# The contents of this file are subject to the terms of the
+# Common Development and Distribution License (the "License").
+# You may not use this file except in compliance with the License.
+#
+# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+# or http://www.opensolaris.org/os/licensing.
+# See the License for the specific language governing permissions
+# and limitations under the License.
+#
+# When distributing Covered Code, include this CDDL HEADER in each
+# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+# If applicable, add the following below this CDDL HEADER, with the
+# fields enclosed by brackets "[]" replaced with your own identifying
+# information: Portions Copyright [yyyy] [name of copyright owner]
+#
+# CDDL HEADER END
+#
+
+#
+# Copyright (c) 2012, Joyent, Inc. All rights reserved.
+#
+
+#
+# Somewhat surprisingly, DTrace very much relies on the fact that when 32-bit
+# is forced, pointers are not, in fact, narrowed to 32-bits.  In particular, if
+# this is not so (that is, if pointers are narrowed to their seemingly correct
+# 32-bit width), helpers attached to 32-bit programs will fail to operate:
+# they will erroneously zero the high 32-bits of the return values of 64-bit
+# kernel pointers as returned by copyin(), alloca(), etc.  This test asserts
+# this implicit behavior -- and this comment regrettably serves as this
+# behavior's only documentation.
+#
+doit()
+{
+	/usr/sbin/dtrace $1 -n BEGIN'{trace(sizeof (long))}' \
+	    -n 'BEGIN{*(int *)alloca(4) = 21506; exit(0)}' \
+	    -n 'ERROR{exit(1)}'
+
+	if [ "$?" -ne 0 ]; then
+		exit $?
+	fi
+}
+
+doit
+doit -32
--- old/usr/src/lib/libdtrace/common/dt_cg.c	2014-01-14 16:47:45.125464386 -0500
+++ new/usr/src/lib/libdtrace/common/dt_cg.c	2014-01-14 16:47:45.140143268 -0500
@@ -476,7 +476,7 @@
 	if (!dt_node_is_scalar(dst))
 		return; /* not a scalar */
 	if (dstsize == srcsize &&
-	    ((src->dn_flags ^ dst->dn_flags) & DT_NF_SIGNED) != 0)
+	    ((src->dn_flags ^ dst->dn_flags) & DT_NF_SIGNED) == 0)
 		return; /* not narrowing or changing signed-ness */
 	if (dstsize > srcsize && (src->dn_flags & DT_NF_SIGNED) == 0)
 		return; /* nothing to do in this case */
--- old/usr/src/pkg/manifests/system-dtrace-tests.mf	2014-01-14 16:47:45.737657578 -0500
+++ new/usr/src/pkg/manifests/system-dtrace-tests.mf	2014-01-14 16:47:45.751241228 -0500
@@ -384,6 +384,7 @@
     mode=0444
 file path=opt/SUNWdtrt/tst/common/arithmetic/tst.execcast.d mode=0444
 file path=opt/SUNWdtrt/tst/common/arithmetic/tst.execcast.d.out mode=0444
+file path=opt/SUNWdtrt/tst/common/arithmetic/tst.nonarrow.ksh mode=0444
 file path=opt/SUNWdtrt/tst/common/arrays/err.D_ARR_BADREF.bad.d mode=0444
 file path=opt/SUNWdtrt/tst/common/arrays/err.D_DECL_ARRBIG.toobig.d mode=0444
 file path=opt/SUNWdtrt/tst/common/arrays/err.D_DECL_ARRNULL.bad.d mode=0444
